SystemOrganization addCategory: #TusLibros2!

!Bag methodsFor: '*tuslibros2' stamp: 'PabloFromer 6/17/2012 23:48'!
copy: anotherBag


	|result|
	
	result := Bag new.

	anotherBag do:[ :element |  result add: element].
	
	^result.
	
! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:12'!
bookSystem
	
	
	
	
	^BookSystem catalogWithPrices: self catalogWithPrices.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:13'!
cashier

^self bookSystem cashier.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:29'!
catalogWithPrices
	
	
	|myCatalog|
	
	myCatalog := Dictionary new.
	
	myCatalog at: 'ISBN-1' put: 1.
	myCatalog at: 'ISBN-2' put: 2.
	
	^myCatalog.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 21:03'!
invalidCreditCard
|expirationDate|

expirationDate := MonthOfYear onMonthNumber: 1 of: 2012.

	^CreditCard ownedBy: self  validOwnerName identifiedBy: self validNumber expiresOn: expirationDate.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:14'!
newCart
	
	
	
	^self bookSystem cart.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:39'!
test01aCartShouldBeEmptyWhenCreated

	|carro|
	
	carro := Cart catalog: self catalogWithPrices.
	
	self assert: (carro isEmpty).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:01'!
test02aCartNotEmptyAfterABookAdded

	|aCart|

 
	aCart:= self newCart. 
	aCart add: 'ISBN-1'.
	self deny:  (aCart isEmpty).
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:37'!
test03aCartShouldContainABookAdded

	|aCart|

 
	aCart:= self newCart. 
	aCart add: 'ISBN-1'.
	self assert:  (aCart includes: 'ISBN-1').
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 13:55'!
test04aCartShouldContainTheSameQuantityOfBookAdded

	|aCart|
	

	aCart:= self newCart.
	aCart add: 'ISBN-1' withOccurrences: 5 .
	self assert: ((aCart occurrencesOf: 'ISBN-1') = 5).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:39'!
test05AfterAddingABookTheOtherBooksRemainInTheCart

	|aCart|
	
	
	aCart:= self newCart.
	aCart add: 'ISBN-1'.
	aCart add: 'ISBN-2'.
	
	aCart catalog at: 'ISBN-3' put: 3.
	
	aCart add: 'ISBN-3'.	
		
	self assert: (aCart includes: 'ISBN-1').
	self assert: (aCart includes: 'ISBN-2').! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:40'!
test06AddingABookNotInTheCatalogRaisesError

	
	
	self
		should: [ self newCart add: 'ISBnNotInCatalog']
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'BookNotInTheCatalog' ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:40'!
test07AddingNegativeQuantitiesToACartRaisesError

	
	
	
	self
		should: [ self newCart add: 'ISBN-1' withOccurrences: (-1) ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'CannotAddNegativeQuantities' ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 16:26'!
test08CheckingOutAnEmptyCartRaisesError

	|cart|
	
	cart:= self newCart.
	
	self
		should: [ self cashier checkOutCart: cart forCreditCard: self validCreditCard ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'CannotCheckOutEmptyCart' ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 16:25'!
test09CheckingOutWithExpiredCreditCardRaisesError

	|cart|
	
	cart:= self newCart.
	
	cart add: 'ISBN-1'.
	
	self
		should: [ self cashier checkOutCart: cart forCreditCard: self invalidCreditCard ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'CannotCheckWithExpiratedCard' ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:41'!
test10CheckingOutAnEmptyCartDoesntCallMerchantProcessor

	|callsBeforeInvalidOperation callsAfterInvalidOperation emptyCart cashier nonEmptyCart|
	
	emptyCart:= self newCart.
	
	nonEmptyCart:= self newCart.
	
	nonEmptyCart add: 'ISBN-1'.
	
	cashier:= self cashier.
	
	cashier checkOutCart: nonEmptyCart forCreditCard: self validCreditCard.
	
	callsBeforeInvalidOperation := cashier totalCalls.
	
	self
		should: [ cashier checkOutCart: emptyCart forCreditCard: self validCreditCard ]
		raise: Error
		withExceptionDo: [ :anError | callsAfterInvalidOperation := cashier totalCalls.
			self assert: callsBeforeInvalidOperation =  callsAfterInvalidOperation ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:42'!
test11CheckingOutWithInvalidCreditCardDoesntCallMerchantProcessor

	|callsBeforeInvalidOperation callsAfterInvalidOperation cashier nonEmptyCart|
	
	
	nonEmptyCart:= self newCart.
	
	nonEmptyCart add: 'ISBN-1'.
	
	cashier:= self cashier.
	
	cashier checkOutCart: nonEmptyCart forCreditCard: self validCreditCard.
	
	callsBeforeInvalidOperation := cashier totalCalls.
	
	self
		should: [ cashier checkOutCart: nonEmptyCart forCreditCard: self invalidCreditCard ]
		raise: Error
		withExceptionDo: [ :anError | callsAfterInvalidOperation := cashier totalCalls.
			self assert: callsBeforeInvalidOperation =  callsAfterInvalidOperation ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:42'!
test12CheckingOutWithInvalidCreditCardDoesntAddSalesToItemsSaled

	|itemsSaledBeforeInvalidOperation itemsSaledAfterInvalidOperation cashier nonEmptyCart|
	
	
	nonEmptyCart:= self newCart.
	
	nonEmptyCart add: 'ISBN-1'.
	
	cashier:= self cashier.
	
	cashier checkOutCart: nonEmptyCart forCreditCard: self validCreditCard.
	
	itemsSaledBeforeInvalidOperation := cashier itemsSaled.
	
	
	self
		should: [ cashier checkOutCart: nonEmptyCart forCreditCard: self invalidCreditCard ]
		raise: Error
		withExceptionDo: [ :anError | itemsSaledAfterInvalidOperation := Bag new copy: cashier itemsSaled.
			
			self assert: itemsSaledBeforeInvalidOperation =  itemsSaledAfterInvalidOperation ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:42'!
test13CheckingOutEmptyCartDoesntAddSalesToItemsSaled

	|itemsSaledBeforeInvalidOperation itemsSaledAfterInvalidOperation cashier emptyCart|
	emptyCart := self newCart.
	
	cashier:= self cashier.
	
	self
		should: [ cashier checkOutCart: emptyCart forCreditCard: self validCreditCard. ]
		raise: Error
		withExceptionDo: [ :anError | itemsSaledAfterInvalidOperation := (Bag new) copy: cashier itemsSaled.
			
			self assert: itemsSaledAfterInvalidOperation size =  0]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 00:18'!
test14ThereAreNoItemsSaledWhenCashierIsJustCreated

	|cashier|
	
	cashier := self cashier.
		
	self assert: (cashier itemsSaled size = 0).
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 20:14'!
test15WhenCheckingWithValidCardAndValidCartAllCartItemsAreAddedToItemsSaled

	|itemsSaledAfterValidOperation cart cashier|
	
	cashier := self cashier.
	
	cart := self newCart.
	
	cart add: 'ISBN-1'.
	
	cart add: 'ISBN-2'.
	
	cashier checkOutCart: cart forCreditCard: self validCreditCard.
	
	self assert: (cashier itemsSaled includes: (BookSold isbn:'ISBN-1'  price:(cashier catalogWithPrices at: 'ISBN-1') ) ).
	self assert: (cashier itemsSaled includes: 'ISBN-2'). 
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 00:25'!
test16totalCallsToMerchantProcessorWhenCashierJustCreatedIsZero

	|cashier|
	
	cashier := self cashier.
	
	self assert: (cashier totalCalls = 0).
	
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 00:44'!
test17WhenCheckingOutWithValidCartAndValidCardTheCashierCallsMerchantProcessor

	|cashier cart1 cart2|
	
	cart1:= self newCart.
	
	cart1 add: 'ISBN-1'.
	
	cart2 := self newCart.
	
	cart2 add: 'ISBN-2'.
	
	cashier := self cashier.
	
	cashier checkOutCart: cart1 forCreditCard: self validCreditCard . 
	
	self assert: (cashier totalCalls = 1).
	
	cashier checkOutCart: cart2 forCreditCard: self validCreditCard . 
	
	self assert: (cashier totalCalls = 2).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:43'!
test18TicketReturnedByCashierReturnsCorrectTotal

	|cashier cart1 cart2 ticket|
	
	cart1:= self newCart.
	
	cart1 add: 'ISBN-1'.
	
	cart1 add: 'ISBN-2'.
	
	cashier := self cashier.
	
	ticket := cashier checkOutCart: cart1 forCreditCard: self validCreditCard . 
	
	self assert: (ticket total = 3).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:44'!
test19TicketReturnedByCashierContainsAllItemsInCart

	|cashier cart1 cart2 ticket|
	
	cart1:= self newCart.
	
	cart1 add: 'ISBN-1'.
	
	cart1 add: 'ISBN-2'.
	
	cashier := self cashier.
	
	ticket := cashier checkOutCart: cart1 forCreditCard: self validCreditCard . 
	
	self assert: (ticket items includes: 'ISBN-1').
	self assert: (ticket items includes: 'ISBN-2').! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 21:03'!
validCreditCard

	^CreditCard ownedBy: self  validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate! !

!TusLibrosTest methodsFor: 'test objects' stamp: 'FromerMaffongelli 6/18/2012 21:02'!
validExpirationDate
	
	^ MonthOfYear januaryOf: 2012! !

!TusLibrosTest methodsFor: 'test objects' stamp: 'FromerMaffongelli 6/18/2012 21:02'!
validNumber
	
	 ^ '0123456789012345'! !

!TusLibrosTest methodsFor: 'test objects' stamp: 'FromerMaffongelli 6/18/2012 21:02'!
validOwnerName

	^ 'Pepe Sanchez'! !

Object subclass: #BookSold
	instanceVariableNames: 'isbn price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!BookSold class methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 18:57'!
isbn:aISBN price:aPrice

	^(self new) isbn: aISBN price:aPrice. ! !

!BookSold methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 20:13'!
isbn
	^isbn.! !

!BookSold methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 18:30'!
isbn:aISBN price:aPrice

	isbn := aISBN.
	price := aPrice.! !

!BookSold methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 20:13'!
price

	^price.! !

Object subclass: #BookSystem
	instanceVariableNames: 'catalogWithPrices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!BookSystem class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:04'!
catalogWithPrices: aCatalog

	^(self new) catalogWithPrices: aCatalog.! !

!BookSystem methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:16'!
cart

 ^Cart catalog: (catalogWithPrices).! !

!BookSystem methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:21'!
cashier

 ^Cashier catalogWithPrices: catalogWithPrices.! !

!BookSystem methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:03'!
catalogWithPrices: aCatalog

	catalogWithPrices := aCatalog.! !

!BookSystem methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:10'!
ticket

 ^Ticket catalogWithPrices: catalogWithPrices.! !

Object subclass: #Cart
	instanceVariableNames: 'items catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 22:33'!
catalog: aCatalog

	^(self new) catalog: aCatalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:33'!
add: aBook

	(catalog includesKey: aBook) ifTrue: [items add: aBook]
	
	 ifFalse: [self error: 'BookNotInTheCatalog']
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:33'!
add: aBook withOccurrences: aSmallInteger

	(catalog includesKey: aBook) ifFalse: [self error: 'BookNotInTheCatalog'].
	
	(aSmallInteger > 0) ifFalse: [self error: 'CannotAddNegativeQuantities'].
	
	items add: aBook withOccurrences: aSmallInteger.
	
	
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 22:34'!
catalog

	^catalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 22:33'!
catalog: aCatalog

	catalog:= aCatalog.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:34'!
includes: aBook

^items includes: aBook.


	
	
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 14:31'!
initialize

	items := Bag new.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 22:47'!
isEmpty

^items size  = 0.


	
	
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:59'!
items

	^items.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/10/2012 23:25'!
occurrencesOf: aBook

	^items occurrencesOf: aBook.! !

Object subclass: #Cashier
	instanceVariableNames: 'catalogWithPrices merchantProcessorInterface itemsSaled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:07'!
catalogWithPrices: aCatalogWithPrices 

^(self new)catalogWithPrices: aCatalogWithPrices.
! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:31'!
catalogWithPrices

	^catalogWithPrices.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:07'!
catalogWithPrices: aCatalogWithPrices

catalogWithPrices:=aCatalogWithPrices.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 20:58'!
checkOutCart: aCart forCreditCard: aCreditCard

|ticket currentMonthOfYear|

currentMonthOfYear := MonthOfYear onMonthNumber: 2 of:  2012. 

ticket := Ticket catalogWithPrices: self catalogWithPrices.

(aCart isEmpty) ifTrue: [self error: 'CannotCheckOutEmptyCart'].

(aCreditCard isExpiredOn: currentMonthOfYear  ) ifTrue: [self error: 'CannotCheckWithExpiratedCard'].

((merchantProcessorInterface chargeThisAmountOfMoney: (self totalAmountForCart: aCart) forthisCreditCard: aCreditCard) = '0|OK') ifTrue: [
	"(aCart items) do:[ :item | itemsSaled add: item ]."
	
	(aCart items) do:[ : item | itemsSaled add: (BookSold isbn: item price: (catalogWithPrices at: item) ) ].
	
	ticket items: aCart items.
	
	^ticket].

! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 6/18/2012 20:40'!
initialize 

	merchantProcessorInterface := MerchantProcessorInterface new.
	itemsSaled := Bag new.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 17:13'!
itemsSaled


^itemsSaled.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 16:51'!
totalAmountForCart: aCart

	|total|
	
	total:=0.

	(aCart items) do:[ :item | total := total + (catalogWithPrices at: item) ].
	
	^total.
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 16:38'!
totalCalls

	^merchantProcessorInterface totalCalls.! !

Object subclass: #MerchantProcessorInterface
	instanceVariableNames: 'totalCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:50'!
chargeThisAmountOfMoney:anAmountOfMoney forthisCreditCard: aCreditCard

totalCalls := totalCalls + 1.

^'0|OK'.! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:49'!
initialize

	totalCalls := 0.! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/17/2012 15:51'!
totalCalls



^totalCalls.! !

Object subclass: #Ticket
	instanceVariableNames: 'items catalogWithPrices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros2'!

!Ticket class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:01'!
catalogWithPrices: aCatalog

	^(self new) catalogWithPrices: aCatalog.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:01'!
catalogWithPrices: aCatalog

	catalogWithPrices := aCatalog.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:45'!
items

	 ^items.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:28'!
items: aBag


	items:= aBag.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'PabloFromer 6/18/2012 01:39'!
total

|result|

result:= 0.

	items do: [:item | result := (result) + (catalogWithPrices at: item)].
	
	^result.! !
